/*
    TUIpeer works in conjunction with an implementation of java.awt.Toolkit
    to provide a Text User Interface for programs using the Java AWT.

    Copyright (C) 1997-2000  Stuart D. Gathman <stuart@bmsi.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/*
 * $Log$
 */
#ifndef __container_h
#define __container_h
#pragma interface
#include "canvas.h"

class ContainerComponent: public Canvas {
  Array<Component *> components;
protected:
  int curfocus;
public:
  ContainerComponent();
  int countComponents() const { return components.size(); }
  Component *getComponent(int i) const { return components[i]; }
  Component *locate(int x,int y) const;
  void add(Component *);
  int indexOf(Controller *);
  void remove(Component *);
  void removeAll();
  void paint(DrawingContext *dc);
  void remoteMethod(int cmd);
  void setfocus(Controller *);
  void setTab(Controller *);
  Component *getTab();
  virtual class FrameComponent *getFrame() const;
  virtual ContainerComponent * obscured();
  void getfocus();
  void losefocus();
  void nextFocus();
  void prevFocus();
  bool focusForward();
  bool focusBackward();
  ~ContainerComponent();
};
#endif
