#ifndef __strlist_h
#define __strlist_h
#pragma interface
#include <String.h>

class StringList {
  StringList(const StringList &);
  StringList&operator=(const StringList &);
  struct Slist {
    Slist *next, *prev;
    Slist() { next = prev = this; }
    ~Slist() { next->prev = prev; prev->next = next; }
    void insert(Slist *p) {
      p->next = this;
      p->prev = prev;
      prev->next = p;
      prev = p;
    }
    String txt;
  };
  int idx, cnt;
  int mod(int i) { return (i < 0) ? i + cnt : i; }
  Slist *find(int);
  Slist *head, *cur;
  String def;	// default value
public:
  StringList();
  String &operator[](int);
  virtual String &insertln(int);
  int size() const { return cnt; }
  void add(const String &s) { insertln(cnt) = s; }
  virtual void deleteln(int);
  virtual void clear();
  virtual ~StringList();
};
#endif
